package de.marcelldietl.blatt1.aufgabe3;

import java.math.BigInteger;
import java.util.concurrent.BlockingQueue;

public class Factorial extends Thread
{
	private BlockingQueue<BigInteger> in;
	
	public Factorial(BlockingQueue<BigInteger> in)
	{
		this.in = in;
	}
	
	public static BigInteger factorial(BigInteger n)
	{
		BigInteger result = BigInteger.ONE;
		
		for (BigInteger i = BigInteger.ONE; i.compareTo(n) <= 0; i = i.add(BigInteger.ONE))
		{
			result = result.multiply(i);
		}
		
		return result;
	}

	@Override
	public void run()
	{
		while (true)
		{
			try
			{
					BigInteger n = in.take();
					System.out.println(n + "! = " + Factorial.factorial(n));
			}
			catch (InterruptedException e)
			{
				break;
			}
		}
	}
}