package de.marcelldietl.blatt1.aufgabe4;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.util.LinkedList;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

public class Main
{
	public static void main(String[] args)
	{
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		
		ExecutorService executor = Executors.newFixedThreadPool(Runtime.getRuntime().availableProcessors());
		
		List<Future<BigInteger>> results = new LinkedList<Future<BigInteger>>();
		
		while(true)
		{
			System.out.print("Geben sie eine Zahl n ein: ");
			
			try
			{
				String line;
				line = in.readLine();
				
				if (line.isEmpty())
				{
					System.out.println("Goodbye!");
					break;
				}
				
				BigInteger n = new BigInteger(line);
				
				results.add(executor.submit(new Factorial(n)));
			}
			catch (IOException e)
			{
				e.printStackTrace();
			}
		}
		
		for (Future<BigInteger> result:results)
		{
				try
				{
					System.out.println(result.get());
				}
				catch (Exception e)
				{
					e.printStackTrace();
				}
		}
		
		executor.shutdown();
	}
}
